﻿
<#

Version 2 tested against Powercli 5.8 and vCenter 6

Requires Vmware Power CLI as well as vCommanders Rest API

****VM Must be powered off to change the MAC Address****

vCommander Run Syntax in vCommander
c:\windows\system32\WindowsPowershell\v1.0\powershell.exe & c:\Scripts\Set_MacAddress.ps1 "#{target.remoteId}" "00:00:00:00:00"
#>

[CmdletBinding()]
	param(
        [Parameter(Mandatory=$True)]
        [string] $VMRid = $(Throw "Provide the VM Remote ID"),
        [string] $Mac = $(Throw "Provide the MAC Address for the vm in the Range 00:50:56:00:00:00 - 00:50:56:3F:FF:FF")
        )

    $VIServer = 'your.vcenter.address.local'    #< vCenter Server name must be reachable (DNS)
    $vCredFile = 'c:\scripts\credentials.xml'   #< vCenter Cred File

################################################################################################################
#Reload modules 
        Write-Host "Loading Modules"
        $moduleName = "VCommanderRestClient"
        If (-not (Get-Module -name $moduleName)) {
                        Import-Module -Name $moduleName 
        } else {
                        Remove-Module $moduleName
                        Import-Module -Name $moduleName 
        }
        $moduleName = "VCommander"
        If (-not (Get-Module -name $moduleName)) {
                        Import-Module -Name $moduleName 
        } else {
                        Remove-Module $moduleName
                        Import-Module -Name $moduleName 
        }
#Connect to vCenter and Disable Cert warnings
# Add the VMware snapin so we can do stuff
add-pssnapin VMware.VimAutomation.Core
$Cred = (New-DecryptCredential -keyFilePath $vCredFile) 
Connect-VIServer -Server $VIServer -Credential $Cred
Write-Host "Connected to $VIServer" 

$VMid = "VirtualMachine-"+$VMRid

Get-VM -Id $VMid | Get-NetworkAdapter | Set-NetworkAdapter -MacAddress $Mac -Confirm:$False 

$AdapterSettings = Get-VM -Id $VMid | Get-NetworkAdapter
$NewMac = $AdapterSettings.MacAddress
Write-Host "New Mac address = $NewMac"